<!--
@license
Copyright (c) 2016 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
-->

<link rel="import" href="../bower_components/polymer/polymer-element.html">
<link rel="import" href="shared-styles.html">
<link rel="import" href="../bower_components/paper-input/paper-input.html">
<link rel="import" href="../bower_components/iron-ajax/iron-ajax.html">
<link rel="import" href="../bower_components/paper-button/paper-button.html">
<link rel="import" href="../bower_components/paper-icon-button/paper-icon-button.html">
<link rel="import" href="../bower_components/paper-dialog/paper-dialog.html">
<link rel="import" href="../bower_components/paper-styles/element-styles/paper-material-styles.html">
<link rel="import" href="../bower_components/iron-flex-layout/iron-flex-layout-classes.html">
<link rel="import" href="dataset-card.html">
<dom-module id="super-search">
  <template>
    <style include="shared-styles paper-material-styles iron-flex iron-flex-alignment">
      :host {
        display: flex;
        flex-direction:column;
        justify-content:center;

        padding: 10px;
      }
      .results {
        width: 50%;
        height:500px;
      }
      .census {
        width:50%;
      }
      .search {
        padding: 0 5px 0 5px;
        margin:auto;
        background: white;
        width: 250px;
        @apply --paper-material-elevation-2;
      }
    </style>
    <paper-dialog id="dialog">
      Details
      <div class="buttons">
        <paper-icon-button dialog-dismiss icon="cancel"></paper-icon-button>
      </div>
    </paper-dialog>
    <iron-ajax auto
      url="/example.json"
      handle-as="json"
      last-response="{{results}}"></iron-ajax>
    <iron-ajax auto url="/example_census.json" handle-as="json" last-response="{{census_results}}"></iron-ajax>
    <paper-input class="search" label="Search" value="{{search}}"></paper-input>
    <div class="horizontal layout">
      <paper-button style="background:#33a02c;color:white" hidden$="[[!download_visible]]" on-click="generateBundle">Download bundle
      </paper-button>
      </div>
    <div class="horizontal layout wrap">
      <template is="dom-repeat" items="[[bundle]]">
        <dataset-card cat="bundle" idx="[[index]]" data="[[item]]" on-view-dataset="viewDialog" on-merge-dataset="addToMergedDatasets"></dataset-card>
      </template>
    </div>
    
    <div class="horizontal layout">
      <div class="results">
        <h3>Results</h3>
        <div class="horizontal layout wrap">
          <template is="dom-repeat" items="[[results]]">
            <dataset-card cat="results" idx="[[index]]" data="[[item]]" on-view-dataset="viewDialog" on-merge-dataset="addToMergedDatasets"></dataset-card>
          </template>
        </div>
      </div>
      <div class="census">
        <h3>ABS datasets</h3>
        <div class="horizontal layout wrap" hidden$="[[!census_visible]]">
          <template is="dom-repeat" items="[[census_results]]">
            <dataset-card cat="abs" idx="[[index]]" data="[[item]]" on-view-dataset="viewDialog" on-merge-dataset="addToMergedDatasets"></dataset-card>
          </template>
        </div>
      </div>
    </div>
  </template>

  <script>
    class SuperSearch extends Polymer.Element {
      static get is() { return 'super-search'; }
      static get properties() {
        return {
          results: Array,
          bundle: {
            type: Array,
            value: () => []
          },
          search: {
            type: String,
            notify: true,
            observer: 'searchChanged'
          },
          census_visible: {
            type: Boolean,
            value: () => true
          },
          download_visible: {
            type: Boolean,
            value: () => false
          }
        }
      }

      static get listeners() {
        return {
          'view-dataset': 'viewDialog'
        }
      }
      viewDialog(e) {
        console.log(e.detail);
        this.$.dialog.open();
      }
      generateBundle(e) {
        console.log('generating bundle')
        fetch('localhost:8000/api/get/bundle',
          {method: 'POST', body: {sets: this.bundle}}).then(resp => {
            console.log('bundle generated, ready for download');
            // simplest way to download a file
            window.open(resp);
        }).catch(err => {
          // squash error
          window.open("https://storage.googleapis.com/super-portal/bundle.zip")
        })
      }
      addToMergedDatasets(e) {
        // handle special case where bundle is empty (need to get link candidates)
        if(this.bundle.length == 0) {
          this.set('download_visible', true)
          this.set('census_visible', true);
          fetch('localhost:8000/api/get/dataset_links',
            {method: 'POST', body: {'id': e.detail.data.id}}).then(resp => {
              // set the bundle object to the list of linkable datasets
              this.set('bundle', resp);
          })
        }
        // remove from the results list
        if(e.detail.data.source_type === 'non_abs') {
          if(e.target.getAttribute('cat') == "results") {
            this.push('bundle', e.detail.data);
            this.splice('results', e.detail.idx, 1);
          } else {
            this.push('results', e.detail.data);
            this.splice('bundle', e.detail.idx, 1);
          }
        } else {
          if(e.target.getAttribute('cat') == 'abs') {
            this.push('bundle', e.detail.data);
            this.splice('census_results', e.detail.idx, 1);
          } else {
            this.push('census_results', e.detail.data);
            this.splice('bundle', e.detail.idx, 1);
          }
        }
        
      }
      handleSearch(e) {
        console.log(this.search);
        fetch('localhost:8000/api/search_packages',
          {method: 'POST', body: {"search": this.search}}).then(resp => {
            this.set('results', resp);
        })
      }

      searchChanged(e) {
        this._handleSearch = Polymer.Debouncer.debounce(
          this._handleSearch, // initially undefined
          Polymer.Async.timeOut.after(200),
          this.handleSearch.bind(this));
      }
    }

    window.customElements.define(SuperSearch.is, SuperSearch);
  </script>
</dom-module>
